'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createBullQueue;

var _bull = require('bull');

var _bull2 = _interopRequireDefault(_bull);

var _priorityQueue = require('bull/lib/priority-queue');

var _priorityQueue2 = _interopRequireDefault(_priorityQueue);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createBullQueue(name) {
  var createQueue = process.env.PRIORITY_QUEUE ? _priorityQueue2.default : _bull2.default;
  var queue = createQueue(name);
  return {
    process: function process(fn) {
      var callbackWrapper = function callbackWrapper(job, done) {
        return fn(job.data, done);
      };
      var promiseWrapper = function promiseWrapper(job) {
        return fn(job.data);
      };

      queue.process(fn.length === 2 ? callbackWrapper : promiseWrapper);
    },
    add: function add(queueItem, opts) {
      return queue.add(queueItem, opts);
    }
  };
}